/*
 * File         : spmd_RootPrintStream.C
 * Author       : Guansong Zhang
 * Created      : Fri Feb  6 14:07:13 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/06 19:17:45 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "spmd_RootPrintStream.h"

/*
 * Class:     spmd_RootPrintStream
 * Method:    printString
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_spmd_RootPrintStream_printString
  (JNIEnv * env, jobject jthis, jstring String)
{
  int length=env->GetStringUTFLength(String);

  char * cString=new char[length+1];

  const char * jStringPtr=env->GetStringUTFChars(String, 0);

  for (int i=0; i<length; i++)
    cString[i]=*(jStringPtr+i);
  cString[length]='\0';

  printf("%s", cString);

  env->ReleaseStringUTFChars(String, jStringPtr);

  delete[] cString;
};
