/*
 * File         : spmd_Spmd.C
 * Author       : Guansong Zhang
 * Created      : Wed Feb  4 10:25:31 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/06 19:17:46 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */


#include <string.h>

#include "spmd_Spmd.h"

#include "adlib.h"

#include "jctable.h"

extern jctable<Group> spmd_Group_Table;

jfieldID hCPPObjID=0;

int len = 0;

char** sargs = 0;

JNIEXPORT void JNICALL Java_spmd_Spmd__1Initialize
  (JNIEnv *env, jclass obj, jobjectArray argv) 
{
  jsize i;
  jstring jc;
  len = env->GetArrayLength(argv);

  //printf("argc=%d\n",len);

  sargs = (char**)calloc(len+1, sizeof(char*));
  for (i=0; i<len; i++) {
    jc=(jstring)env->GetObjectArrayElement(argv,i);
    sargs[i]=new char[strlen(env->GetStringUTFChars(jc,0))];
    strcpy(sargs[i],env->GetStringUTFChars(jc,0));

    //printf("sargs[%d]:%s\n",i,sargs[i]);
  }

  //printf("AdlibInit...\n");

  AdlibInit(len, sargs);

}

JNIEXPORT void JNICALL Java_spmd_Spmd__1Finalize
  (JNIEnv *env, jclass obj) {
  int i;

  //printf("AdlibFinalize...\n");

  AdlibFinalize();

  for (i=0; i<len; i++)
    //free(sargs[i]);
    delete [] sargs[i];
  free(sargs);
}

/*
 * Class:     spmd_Spmd
 * Method:    _InitInterFace
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Spmd__1InitInterFace
  (JNIEnv * env, jclass jthis)
{
  //to init hCPPObjID;
  jclass InterfaceObject_class=env->FindClass("spmd/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
}

/*
 * Class:     spmd_Spmd
 * Method:    _InitAPG
 * Signature: (Lspmd/Group;)V
 */
JNIEXPORT void JNICALL Java_spmd_Spmd__1InitAPG
  (JNIEnv * env, jclass jthis, jobject jGroup)
{
  int pos = env->GetIntField(jGroup, hCPPObjID);

  delete (spmd_Group_Table.ObjPtr[pos]);

  spmd_Group_Table.ObjPtr[pos]=&apg;
};

/*
 * Class:     spmd_Spmd
 * Method:    clock
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_spmd_Spmd_clock
  (JNIEnv * env, jclass jthis, jint seed)
{
  AdlibClock(seed);
}
