
// Operations on collapsed ranges.


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CollapsedRangeRep': collapsed template range.                //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class CollapsedRangeRep : public RangeRep {
public :
  CollapsedRangeRep(RangeRep* _kernel, const int _extent) :
          RangeRep(_extent, _kernel, 1, _kernel->dim()) {
    kernel->incr() ;
  }

  ~CollapsedRangeRep() {
    kernel->decr() ;
  }

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  Format format() const ;

  int ker_glb(const int glb, int* sub) const ;

  int block(const int ker_glb, int* sub, int* count) const ;
  int block_step(int* sub_stp) const ;

  int width() const ;
  StrideRep* vector(StrideRep* _kernel, const int _length) const ;

  void show() ;

MEMORY_POOL_DECS
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CollapsedSubRangeRep': collapsed subrange.                   //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class CollapsedSubRangeRep : public RangeRep {
public :
  CollapsedSubRangeRep(const int _extent,
		       const int _base, const int _stride,
		       CollapsedRangeRep* _parent,
		       RangeRep* _kernel) :
          RangeRep(_extent, _kernel, 1, _kernel->dim()),
	  base(_base), stride(_stride), parent(_parent) {
    parent->incr() ;
  }

  ~CollapsedSubRangeRep() {
    parent->decr() ;
  }

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  RangeRep* tem() ;
  int bas() const ;
  int str() const ;

  Format format() const ;

  int ker_glb(const int glb, int* sub) const ;

  int block(const int ker_glb, int* sub, int* count) const ;
  int block_step(int* sub_stp) const ;

  int width() const ;
  StrideRep* vector(StrideRep* _kernel, const int _length) const ;

  int glb(const int sub, const int ker_glb) const ;

  void show() ;

protected :
  int base, stride ;
  CollapsedRangeRep* parent ;

MEMORY_POOL_DECS
} ;


// -------------------------------------------------------------
// Things to do
//
//   Revert to `CollapsedSubRangeRep' derived from `CollapsedRangeRep'.

