
// Operations on level-0 ranges.


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `DimRangeRep': process dimension range.                       //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class DimRangeRep : public RangeRep {
public : 
  DimRangeRep() : RangeRep(1, 0, 0, Dimension()) {}

  DimRangeRep(Dimension _dim) : RangeRep(_dim ? _dim.size() : 1, 0, 0, _dim) {}

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  Format format() const ;

//  int block(const int ker_glb, int* sub, int* count) const ;
//  int block_step(int* sub_stp) const ;

  int crd(const int glb) const ;
  int local(int* glb) const ;

  void show() ;

MEMORY_POOL_DECS
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `DimSubRangeRep': process dimension subrange.                 //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class DimSubRangeRep : public RangeRep {
public :
  DimSubRangeRep(const int _extent, const int _base, const int _stride,
                 DimRangeRep* _parent, Dimension _dim) :
          RangeRep(_extent, 0, 0, _dim),
	  base(_base), stride(_stride), parent(_parent) {
    parent->incr() ;
  }

  ~DimSubRangeRep() {
    parent->decr() ;
  }

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  RangeRep* tem() ;
  int bas() const ;
  int str() const ;

  Format format() const ;

//  int block(const int ker_glb, int* sub, int* count) const ;
//  int block_step(int* sub_stp) const ;

  int crd(const int glb) const ;
  int local(int* glb) const ;

  int glb(const int sub, const int ker_glb) const ;

  void show() ;

protected :
  int base, stride ;
  DimRangeRep* parent ;

MEMORY_POOL_DECS
} ;


// -------------------------------------------------------------
// Things to do
//
//   Derived `DimSubRangeRep' from `DimRangeRep'.

