/*
 * File         : Jacobi_S.java
 * Author       : Guansong Zhang
 * Created      : Mon Feb  2 10:36:02 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/20 17:01:48 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class Jacobi_S {

  static final int n=1024;

  public static void main(String argv[]) {
    float a [] = new float [n*n];

    int i, j;

    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	if (i==0 || i==n-1 || j==0 || j==n-1)
	  a[i*n+j]=1;
	else
	  a[i*n+j]=0;
      }
    }

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i*n+j]+" ");
      };
    
      System.out.println();
    }
    */

    float b [] = new float [n*n];

    for (int iter=0; iter <100; iter++) {

      if (iter==10)
	Spmd.clock(0);
      
      for (i=0; i<n; i++) {
	for (j=0; j<n; j++) {
	  int b_bas=i*n+j;
	  int a_bas=b_bas;
	  b[b_bas]=a[a_bas];
	}
      }

      for (i=1; i<n-1; i++) {
	for (j=1; j<n-1; j++) {
	  int a_bas=i*n+j;
	  int b_bas=a_bas;
	  a[a_bas]=((b[b_bas-n]+b[b_bas+n]+b[b_bas-1]+b[b_bas+1])*(float)0.25);
	}
      }
    }

    Spmd.clock(1);

    /*
    for (i=0; i<n; i++) {
      for (j=0; j<n; j++) {
	System.out.print(a[i*n+j]+" ");
      };
    
      System.out.println();
    }
    */
  }
}
